#ifndef RUMBA_PARSE_CSV_H
#define RUMBA_PARSE_CSV_H
#include <list>
#include <string>
#include <iosfwd>
#include <rumba/header_request.h>


/**
  * \file parsecsv.h
  * \author Donovan Rebbechi, Ben Bly, Giorgio Grasso
  * Copyright Ben Bly
  * This file is released under the artistic license. See the file
  * COPYING for details.
  */



namespace RUMBA 
{
/**
 *  Function for decomposing a CSV header format specification into a 
 *  representation as a list of header_request objects
 */
void parseCsv ( std::list<RUMBA::header_request> &, std::istream& );
}

#endif
